class LoadWeapon expands Mutator config (RandomWeapon);

var() config array<string> AWeapon;
var() config array<string> AnAmmo;
var() config float AmmoScale;
var bool bEnabled;
var int i, k;

const version="1.00";

event PostBeginPlay()
{
	i = 0;
	log ("LoadWeapon version"@version@"attempt initialization process...",'RandWeapon');
	if ( AmmoScale <= 0.2)
		AmmoScale = 0.2;
	DoInit();
Done:
	if ( bEnabled )
		log (Self.Name@"has been Initialized.",'RandWeapon');
	else
		log (Self.Name@"has encountered a bad configuration, it will not load anything...",'RandWeapon');
}

final function DoInit()
{
	local bool bKeepGoing;
	local class<Weapon> W;
	local class<Ammo> A;

Top:
	W = class<Weapon>( DynamicLoadObject(AWeapon[i], class'Class', True) );
	if ( W != None )
	{
		bKeepGoing = True;
	}
	else
	{
		bKeepGoing=False;
	}
	A = class<Ammo>( DynamicLoadObject(AnAmmo[i], class'Class', True) );
	if ( A == None )
	{
		bKeepGoing=False;
	}
	if ( bKeepGoing )
	{
		W = None;
		A = None;
		i++;
		bEnabled = True;
	}
	else
		GoTo Initialized;
GoTo Top;
Initialized:
	k = i;
}

function ModifyPlayer (Pawn Other)
{
	local class<Ammo> Am;
	local class<Weapon> Wp;
	local Ammo A;
	local Weapon W;
	local int j;

	if ( Other.PlayerReplicationInfo == None && Other.bIsPlayer )
		GoTo FagitronSet;
	if ( bEnabled )
	{
		j = INT(RandRange(0,k));
		log("Weapon sorted for"@Other.GetHumanName()@"is number: "$j$".",'RandWeapon');
		for ( i = 0; i < k+1; i++ )
		if ( !Other.bHidden )
		{
			if (i == j)
			{
//Loading Ammo first
				Am = class<Ammo>( DynamicLoadObject(AnAmmo[i], class'Class', True) );
				if ( Am != None )
				{
					A = Spawn (Am,,,Other.Location,Other.Rotation);
					if ( A != None )
					{
						A.RespawnTime = 0.00;
						A.AmmoAmount *= AmmoScale;
						A.Touch(Other);
					}
				}
//Now load weapon accordingly
				Wp = class<Weapon>( DynamicLoadObject(AWeapon[i], class'Class', True) );
				if ( Wp != None )
				{
					W = Spawn(Wp,,,Other.Location,Other.Rotation);
					if ( W != None )
					{
						W.RespawnTime = 0.00;
						W.Touch(Other);
					}
				}
				Am = None; A = None; Wp = None; W = None;
			}
		}
	}
	Super.ModifyPlayer(Other);
FagitronSet:
//Ruin chain for shite
}

defaultproperties
{
	AmmoScale=5.000000
}
